;PROGRAM modpwd.asm
;
org 0100h
mov ax,03d02h
xor cx,cx
mov dx,offset devname
int 21h
jnc drvr_found

mov ah,09
mov dx,offset no_drvr
int 21h
jmp error_pass


drvr_found:
mov bx,ax
mov ax,04402h
mov cx,20                   ;read 20 characters
mov dx,offset databuffr
int 21h

mov pass_len,al
dec al
mov ah,al
and al,0fh
mov cl,4
shr ah,cl
add ax,03030h
cmp al,'9'
jbe inrange
add al,7
inrange:
cmp ah,'9'
jbe inrange1
add ah,7
inrange1:
mov byte ptr [num_chr],ah
mov byte ptr [num_chr+1],al


cld
mov di,offset databuffr-1
xor cx,cx
mov cl,pass_len
add di,cx
mov si,offset pass_end
mov cx,stringsz
repe movsb

;check for information in command line
;else--> prompt for user input
mov al,pass_len
or byte ptr [0080h],0
jz req_input
mov cl,[0080h]
dec cl
mov [0081h],cl
mov si,0081h
mov di,offset newpass
mov cx,20
repe movsb
jmp vrfy_info

req_input:
mov ah,09
mov dx,offset cur_pass
int 21h

mov ah,0a
mov dx,offset pass_len
int 21h


vrfy_info:
mov ax,word ptr [pass_len]
cmp ah,0
jz error_pass
dec al
cmp ah,al
jnz error_len

;change the current password
xor cx,cx
mov cl,al
mov ah,044h
mov al,03
mov dx,offset newpass+1
int 21h
jnc success_pass

error_len:
mov ah,09
mov dx,offset errormsg
int 21h

error_pass:
mov ax,04c01h                     ;abnormal termination
int 21h

success_pass:
mov ax,04c00h
int 21h


devhandle  dw ?
cur_pass   db 'Current password is ['
databuffr  db 20 dup (?)
pass_end   db ']      ;'
num_chr    db '  '
           db ' characters',0ah,0dh,0ah,0dh
prompt     db 'New word: ','$'
stringsz  equ $ - pass_end

pass_len   db 00
newpass    db 20 dup (?)
errormsg   db 'error changing password!',0ah,0dh,'$'
no_drvr    db 'Error: '
devname    db "HACKPWD ",00
           db 'device driver not loaded!',0ah,0dh,07,'$'
